QGIS Application - Bug report #1876

PostgreSQL text fields become zero-length strings when blanked on attribute update edits from
QGIS

2009-08-14 05:36 PM - Mike Taves

Status: Closed

Priority: Low

Assignee: Jurgen Fischer

Category: Data Provider

Affected QGIS version:master Regression?: No
Operating System: All Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupls data: Copied to github as #: 11936
Description

This bug is simple to create in QGIS 1.0.x and 1.2.x.

Edit any [[PostGIS]] layer with several text fields:

1. Add a geometry feature in QGIS, but leave some text fields blank when adding attributes; commit

1. View database record in another client app (e.g., [[PgAdminlIl]]) to ensure that blank fields are NULL
1. Edit the feature attributes by adding text to a NULL field;

1. In QGIS, edit the feature attributes, but delete the text; commit

Strictly speaking, this is not a bug, but is in a grey-area leaning toward "feature". Many client apps, like MS Access and pgAdminlll,
consider zero-length strings to be NULLSs. | prefer this behaviour, since it is consistent to the creation of the features in QGIS when no text
has been added to some fields these were inserted as NULLs and not zero-length strings.

Associated revisions

Revision 2db782f4 - 2009-08-16 12:28 AM - Jiirgen Fischer
attribute editor fixes:
- fix column misindexing in attribute table, if the geometry column is not last

- fix NULL handling (fixes #1876)

git-svn-id: http://svn.osgeo.org/qgis/trunk/qgis@11392 ¢8812cc2-4d05-0410-92ff-de0c093fc19c

Revision d0c19c5c¢ - 2009-08-16 12:28 AM - Jiirgen Fischer
attribute editor fixes:
- fix column misindexing in attribute table, if the geometry column is not last

- fix NULL handling (fixes #1876)

git-svn-id: http://svn.osgeo.org/qgis/trunk@11392 ¢8812cc2-4d05-0410-92ff-de0c093fc19c

History

#1 - 2009-08-15 03:41 PM - Jiirgen Fischer

Replying to mwtoews:

Strictly speaking, this is not a bug, but is in a grey-area leaning toward "feature”.
http://svn.osgeo.org/qgis/trunk/qgis@11392
http://svn.osgeo.org/qgis/trunk@11392
/issues/show/1876

Well, | consider it a bug. 1. NULL and an empty string are different values. And 2. if you don't touch the value, the value should stay the same.

#2 - 2009-08-15 04:18 PM - Jiirgen Fischer
- Resolution set to fixed

- Status changed from Open to Closed

#3 - 2012-09-25 05:47 AM - Regis Haubourg

- Crashes QGIS or corrupts data set to No
- Affected QGIS version set to master

Hi,
testing today with 7ce99b8, postgres 9.1, postgis 1.5, | see a regression on that important feature.

Anyone confirms?

#4 - 2012-09-25 05:50 AM - Jiirgen Fischer
- Pull Request or Patch supplied set to No

regis Haubourg wrote:

testing today with 7ce99b8, postgres 9.1, postgis 1.5, | see a regression on that important feature.

In what way?

#5 - 2012-09-25 06:04 AM - Regis Haubourg

Sorry,
manually removing a value still writes a zero length string and not a null value..

#6 - 2012-09-25 06:25 AM - Jiirgen Fischer

regis Haubourg wrote:

manually removing a value still writes a zero length string and not a null value..

But that's the intended behaviour. If you enter an empty string, you get an empty string in the database - if you want a null value enter the string
representation for NULL (which is configurable in options and NULL by default).

#7 - 2012-09-25 06:43 AM - Regis Haubourg

OK, got it better. It tried to type 'NULL', but | couldn't make it saved correctly in Postgis. I'm not able to reproduce again.. so it might be related to something
else when commiting. I'll test furthermore. You can close the issue and sorry for the noise.
